@echo off
rem using utmp and tmp

set log=c:\
set e3=.5c5

set ud=c:\tools
set pr=cs

set arbo=c:\tools\cs
set dt=delta

pushdir

if "%1"=="" goto syntax
if not "%2"=="" goto syntax
for %%s in (COMPARE REPORT BUILD MAKE VERIFY UPDATE CLEAN) do if "%1"=="%%s" goto %1
for %%s in (compare report build make verify update clean) do if "%1"=="%%s" goto %1
for %%s in (CMP RPT BLD MAK VER UPD CLN) do if "%1"=="%%s" goto %1
for %%s in (cmp rpt bld mak ver upd cln) do if "%1"=="%%s" goto %1
for %%s in (C R B M V U K) do if "%1"=="%%s" goto %1
for %%s in (c r b m v u k) do if "%1"=="%%s" goto %1
rem for backwards compatibility with older batches !
for %%s in (FORCE F force f) do if "%1"=="%%s" goto %1

:syntax
echo Syntax : %0 command
echo.
echo COMPARE CMP : compare current drive %log% against archived logfile, then view
echo REPORT  RPT : just create COMPARE report, without running List to view it
echo BUILD   BLD : create new logfile for drive %log%, asking for confirmation
echo MAKE    MAK : just BUILD logfile, without asking confirmation
echo VERIFY  VER : verify archived logfile
echo UPDATE  UPD : update reference archive
echo CLEAN   CLN : delete current logfile as not to update archive by accident

call proctime mdfive c

goto end

rem -------------------------------------------------------------

:compare
:cmp
:c
:report
:rpt
:r
if not exist %ud%\%pr%.zip goto missing
%utmp%
cd %tmp%
call uz -o %ud%\%pr% %pr%%e3%
if not exist %pr%%e3% goto missingrpt

echo Please wait...
echo.
if exist cs.ref del cs.ref
ren %pr%%e3% cs.ref

dt "elapsed $m \h " /B /f:"$D/$m/$yyyy 0h:0m" > %dt%.bat

echo Creating data for current drive %log%
rem use the very same switches than in BUILD command
%ud%\%pr% %log% -m > %pr%%e3%

echo.
echo Comparing older and newer logs
%ud%\%pr% cs.ref %pr%%e3% -d -k -y -w > rpt%e3%
del cs.ref

rem M$ BRAIN-DAMAGED COPY COMMAND DOES NOT LIKE TRAILING BACKSLASH !!!
copy %pr%%e3% %ud%

call zz %ud%\%pr% %pr%%e3%
del %pr%%e3%

rem create delthem._?_ from terse rpt%e3% in order to quickly remove added files
copy rpt%e3% delthem%e3%
newline -k "Added     # "        delthem%e3%
oldnew  -r "Added     # " "del " delthem%e3%
if exist delthem.bk! del delthem.bk!

rem if exist delthem.bat del delthem.bat
rem ren delthem%e3% delthem.bat

rem handle tree (not done by our chkdata !)

call uz -o %ud%\%pr% tree%e3%
if not exist tree%e3% goto missingtree

if exist tree.ref del tree.ref
ren tree%e3% tree.ref

echo Comparing trees
%arbo% %log% /s > tree%e3%
%arbo% -k tree.ref tree%e3% >> rpt%e3%
del tree.ref
copy tree%e3% %ud%
del tree%e3%

dt "\h" /B /f:"$D/$m/$yyyy 0h:0m" >> %dt%.bat
newline -a " > %dt%%e3%"              %dt%.bat
call %dt%
newline -p "; Total processing completed in approximately " %dt%%e3%
concat -n -d rpt%e3% %dt%%e3%
del rpt.bk!
del %dt%.bat
del %dt%.bk!

for %%s in (COMPARE CMP C compare cmp c) do if "%1"=="%%s" goto listit
for %%s in (REPORT RPT R report rpt r) do if "%1"=="%%s" goto typeit

:listit
rem call xga
list rpt%e3% report%e3%
goto done

:typeit
rem type rpt%e3%
rem type report%e3%
goto done

:done
echo.
echo report%e3% was created in %tmp% directory !
echo You may UPDATE %pr%.zip with %pr%%e3% log now moved to %ud%\
goto end

rem -------------------------------------------------------------

:build
:bld
:b
if not exist %ud%\%pr%.zip goto okmake
echo Warning ! %ud%\%pr%.zip reference logfile already exists !
echo.
choice /c:YN /n /t:N,5 Hit 'Y' within next 5 seconds to replace existing log :
echo.
if errorlevel 2 goto end
:okmake
%utmp%
cd %tmp%
echo Please wait...
%ud%\%pr% %log% -m > %pr%%e3%
if errorlevel 1 goto problem
call zz %ud%\%pr% %pr%%e3%
del %pr%%e3%
goto end

rem -------------------------------------------------------------

:make
:mak
:m
:force
:f
if exist %ud%\%pr%.zip echo Warning ! %ud%\%pr%.zip reference logfile already existed !
goto okmake

rem -------------------------------------------------------------

:verify
:ver
:v
if not exist %ud%\%pr%.zip goto missing
%utmp%
cd %tmp%
call uz %ud%\%pr% %pr%%e3%
if not exist %pr%%e3% goto missingrpt
echo Please wait...
%ud%\%pr% %pr%%e3% -v -w > %pr%.rpt
del %pr%%e3%

rem list %pr%.rpt
type %pr%.rpt

echo.
echo %pr%.rpt report was created in %tmp% directory !
goto end

rem -------------------------------------------------------------

:update
:upd
:u
call %ud%\update x x
goto end

rem -------------------------------------------------------------

:clean
:cln
:k
if not exist %ud%\%pr%%e3% goto nolog
if not exist %ud%\tree%e3% goto noarbo
del %ud%\%pr%%e3%
del %ud%\tree%e3%
echo.
echo Files matching *%e3% have been deleted !
goto end

rem -------------------------------------------------------------

:problem
echo.
echo ********************************************************************
echo *** CS did not return success, check for possible problem ! ***
echo ********************************************************************
dir %tmp%\%pr%.*
goto end

rem -------------------------------------------------------------

:missing
echo %ud%\%pr%.zip reference logfile does not exist !
goto end

rem -------------------------------------------------------------

:missingrpt
echo %ud%\%pr%%e3% logfile was not found in %ud%\%pr%.zip archive !
goto end

rem -------------------------------------------------------------

:missingtree
echo %ud%\tree%e3% was not found in %ud%\%pr%.zip archive !
goto end

rem -------------------------------------------------------------

:nolog
echo %ud%\%pr%%e3% does not exist !
goto end

rem -------------------------------------------------------------

:noarbo
echo %ud%\tree%e3% does not exist !
goto end

rem -------------------------------------------------------------

:end

popdir

set dt=
set arbo=

set pr=
set ud=
set e3=
set log=

